/******************************************************************************
 *
 * Copyright (c) 2019, the jupyter-fs authors.
 *
 * This file is part of the jupyter-fs library, distributed under the terms of
 * the Apache License 2.0.  The full license can be found in the LICENSE file.
 *
 */
import { WidgetTracker } from "@jupyterlab/apputils";
import { ClipboardModel, ContentsModel, IContentRow } from "@tree-finder/base";
import type { TreeFinderSidebar } from "./treefinder";
export declare class JupyterClipboard {
    constructor(tracker: WidgetTracker<TreeFinderSidebar>);
    refresh<T extends IContentRow>(tm?: ContentsModel<T>, memo?: T[]): void;
    refreshSelection<T extends IContentRow>(tm: ContentsModel<T>): void;
    get model(): ClipboardModel;
    protected _onDelete<T extends IContentRow>(src: T): Promise<void>;
    protected _onPaste<T extends IContentRow>(src: T, destPathstr: string, doCut: boolean): Promise<void>;
    protected _model: ClipboardModel;
    protected _tracker: WidgetTracker<TreeFinderSidebar>;
    private _drive;
}
