import { Contents } from "@jupyterlab/services";
import { IContentRow } from "@tree-finder/base";
/**
 * Wrapper for a drive onto the contents manager.
 */
export declare class ContentsProxy {
    constructor(contentsManager: Contents.IManager, drive?: string, onGetChildren?: ContentsProxy.GetChildrenCallback);
    get(path: string, options?: Contents.IFetchOptions): Promise<ContentsProxy.IJupyterContentRow>;
    save(path: string, options?: Partial<Contents.IModel>): Promise<ContentsProxy.IJupyterContentRow>;
    rename(path: string, newPath: string): Promise<ContentsProxy.IJupyterContentRow>;
    newUntitled(options: Contents.ICreateOptions): Promise<ContentsProxy.IJupyterContentRow>;
    downloadUrl(path: string): Promise<string>;
    readonly contentsManager: Contents.IManager;
    readonly drive?: string;
    readonly onGetChildren?: ContentsProxy.GetChildrenCallback;
}
export declare namespace ContentsProxy {
    interface IJupyterContentRow extends Omit<Contents.IModel, "path" | "content" | "type">, IContentRow {
    }
    type GetChildrenCallback = (path: string, done: Promise<void>) => void;
    function toFullPath(path: string, drive?: string): string;
    function toLocalPath(path: string): string;
    function toJupyterContentRow(row: Contents.IModel, contentsManager: Contents.IManager, drive?: string, onGetChildren?: ContentsProxy.GetChildrenCallback): IJupyterContentRow;
}
