/******************************************************************************
 *
 * Copyright (c) 2019, the jupyter-fs authors.
 *
 * This file is part of the jupyter-fs library, distributed under the terms of
 * the Apache License 2.0.  The full license can be found in the LICENSE file.
 *
 */
import { ISettingRegistry } from "@jupyterlab/settingregistry";
import type { IFSResource, IFSSettingsResource } from "./filesystem";
/**
 * Migrate any settings from an older version of the package
 *
 * @param settings Our settings to consider for migratation
 * @returns The modified settings object
 */
export declare function migrateSettings(settings: ISettingRegistry.ISettings): Promise<ISettingRegistry.ISettings>;
/**
 * Ensure undefined string values from settings that are required are translated to empty strings
 * @param settingsResoruce
 * @returns A filled in setting object
 */
export declare function unpartialResource(settingsResource: IFSSettingsResource): IFSResource;
