/******************************************************************************
 *
 * Copyright (c) 2019, the jupyter-fs authors.
 *
 * This file is part of the jupyter-fs library, distributed under the terms of
 * the Apache License 2.0.  The full license can be found in the LICENSE file.
 *
 */
import { Widget } from "@lumino/widgets";
import JSZip from "jszip";
export declare const Patterns: {
    tree: RegExp;
    workspace: RegExp;
};
/**
 * Version of btoa that omits any "=" padding chars at the end
 */
export declare function btoaNopad(s: string): string;
export declare function createOpenNode(): HTMLElement;
export declare function promptRename(text: HTMLElement, edit: HTMLInputElement, original: string): Promise<string>;
export declare function fileSizeString(fileBytes: number): string;
export declare function switchView(mode: any): "none" | "";
export declare function writeZipFile(zip: JSZip, path: string): void;
export declare class OpenDirectWidget extends Widget {
    constructor();
    getValue(): string;
    get inputNode(): HTMLInputElement;
}
